{$APPTYPE CONSOLE}

program sol_gg;
const
  MAX_N = 100;
  MAX_K = 100;
var
  a: array[0..MAX_K-1, 1..MAX_N, 1..MAX_N] of integer;
  f: array[0..MAX_K-1, 1..MAX_N, 1..MAX_N] of integer;
  T: array[1..MAX_N, 1..MAX_N] of integer;
  N, K: integer;
  m: integer;
  i, j, l: integer;
begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  read(N, K);
  assert((N >= 2) and (N <= MAX_N));
  assert((K >= 1) and (K <= MAX_K));
  for i := 1 to N do
  begin
    for j := 1 to N do
    begin
      assert(not SeekEof(input));
      read(T[i,j]);
      assert((T[i,j] >= 2) and (T[i,j] <= 100));
    end;
  end;
  assert(SeekEof(input));

  for l := 0 to K-1 do
  begin
    for i := 1 to N do
    begin
      for j := 1 to N do
        a[l,i,j] := l mod T[i,j];
    end;
  end;
  for i := 1 to N do
  begin
    for j := 1 to N do
      f[0,i,j] := a[0,i,j];
  end;
  for l := 1 to K-1 do
  begin
    for i := 1 to N do
    begin
      for j := 1 to N do
      begin
        m := 0;
        if ((i > 1) and (f[l-1,i-1,j] > m)) then
          m := f[l-1,i-1,j];
        if ((i < N) and (f[l-1,i+1,j] > m)) then
          m := f[l-1,i+1,j];
        if ((j > 1) and (f[l-1,i,j-1] > m)) then
          m := f[l-1,i,j-1];
        if ((j < N) and (f[l-1,i,j+1] > m)) then
          m := f[l-1,i,j+1];
        f[l,i,j] := a[l,i,j] + m;
      end;
    end;
  end;

  m := 0;
  for i := 1 to N do
  begin
    for j := 1 to N do
    begin
      if (f[K-1,i,j] > m) then
        m := f[K-1,i,j];
    end;
  end;
  write(m);

  close(input);
  close(output);
end.